#include <iostream>
#include <vector>
#include <algorithm>

typedef long long ll;

using namespace std;

bool check(vector<vector<ll>> &v, ll &p, ll &x) {
    ll sm = 0;

    for (int i = 0; i < v.size(); i++) {
        if (x <= v[i][0]) {
            sm += v[i][1] * x;
        } else {
            sm += v[i][1] * v[i][0] + v[i][2] * (x - v[i][0]);
        }
    }

    return sm < p;
}

int main() {
    ll n, p;
    cin >> n >> p;
    vector<vector<ll>> v(n);

    for (int i = 0; i < n; i++) {
        ll z, x, y;
        cin >> z >> x >> y;
        v[i].push_back(z);
        v[i].push_back(x);
        v[i].push_back(y);
    }

    ll l = 0, r = 1e13;

    while (l + 1 < r) {
        ll mid = (l + r) / 2;

        if (check(v, p, mid)) {
            l = mid;
        } else {
            r = mid;
        }
    }

    cout << r;
}