#include <iostream>
#include <vector>
#include <algorithm>

typedef long long ll;

using namespace std;

ll solve(vector<ll> to, ll step, ll n) {
    if (step == n) {
        return 1;
    }
    ll sm = 0;
    for (int i = 1; i <= 8; i++) {
        vector<ll> to2;
        for (auto j : to) {
            to2.push_back(j + 1);
        }
        if (to[i] >= i) {
            to2[i] = 1;
            sm += solve(to2, step + 1, n);
            sm = sm % (ll(1e9 + 7));
        }
    }

    return sm % (ll(1e9 + 7));
}

int main() {
    int n, m;
    cin >> n >> m;

    vector<ll> to(9, -1e5 + 1);

    for (int i = 0; i < m; i++) {
        int k;
        cin >> k;
        to[k] = 10;
    }
    ll ans = solve(to, 0, n);
    cout << ans;

}