#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

void solve();

ll s = 0;

void fill(vector<vector<bool>> &v, int x, int y, int k) {
    for (int i = 0; i < k; i++) {
        for (int j = 0; j < k; j++) {
            if (!v[x + i][y + j]) s += 1;
            v[x + i][y + j] = true;
        }
    }
}

int main() {
    int t = 1;
//    cin >> t;

    while (t--) {
        solve();
    }
}

void solve() {
    int k, n;
    cin >> k >> n;

    vector<pair<char, int>> v(n);

    for (auto &i : v) {
        cin >> i.first >> i.second;
    }

    vector<vector<bool>> pole(1e6 * 2, vector<bool> (1e6 * 2, false));
    int x = 1e4, y = 1e4;
    fill(pole, x, y, k);
    for (int i = 0; i < n; i++) {
        if (v[i].first == 'N') {
            for (int j = 0; j < v[i].second; j++) {
                y += 1;
                fill(pole, x, y, k);
            }
        } else if (v[i].first == 'S') {
            for (int j = 0; j < v[i].second; j++) {
                y -= 1;
                fill(pole, x, y, k);
            }
        }
        if (v[i].first == 'W') {
            for (int j = 0; j < v[i].second; j++) {
                x -= 1;
                fill(pole, x, y, k);
            }
        } else if (v[i].first == 'E') {
            for (int j = 0; j < v[i].second; j++) {
                x += 1;
                fill(pole, x, y, k);
            }
        }
    }

    cout << s;
}

