#include <iostream>
#include <vector>
#include <algorithm>

typedef long long ll;

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;

    vector<bool> v(9, false);

    for (int i = 0; i < m; i++) {
        int k;
        cin >> k;
        v[k] = true;
    }

    vector<vector<ll>> dp(n + 1, vector<ll> (2, 1));
    for (int i = 2; i <= n; i++) {
        for (int j = 0; j < 2; j++) {
            if (j == 0)
                dp[i][j] = (dp[i - 1][j] + dp[i - 1][j + 1]) % ll (1e9 + 7);
            else
                dp[i][j] = dp[i - 1][j - 1];
        }
    }

    cout << (dp[n][0] + dp[n][1]) % ll (1e9 + 7);
}