#include <iostream>
#include <vector>
#include <algorithm>

typedef long long ll;

using namespace std;

bool solve(vector<int> &v, vector<bool> used, int p, int k, int step, int cur) {
    if (step == k) {
        if (cur + 1 == p) {
            return true;
        }
        return false;
    }
    cur = -1;
    for (int i = 0; i < v.size(); i++) {
        if (used[i]) {
            if ((i != 0) && (!used[i - 1])) cur = i - 1;
            if ((i != v.size() - 1) && (!used[i + 1] )) {
                if (cur == -1 || v[cur] > v[i + 1])
                    cur = i + 1;
            }
        }
    }


    used[cur] = true;
    return solve(v, used, p, k, step + 1, cur);
}

int main() {
    int n, q;
    cin >> n >> q;

    vector<int> v(n);

    for (auto &i : v) {
        cin >> i;
    }

    for (int Q = 0; Q < q; Q++) {
        int p, k;
        cin >> p >> k;
        int ans = 0;
        for (int j = 0; j < n; j++) {
            vector<bool> used(n, false);
            used[j] = true;
            if (solve(v, used, p, k, 1, j)) {
                ans++;
            }
        }
        cout << ans << endl;
    }

}